//===----------------------------------------------------------------------===//
//
// Philipp Schubert
//
//    Copyright (c) 2017 - 2021
//    Secure Software Engineering Group
//    Heinz Nixdorf Institute
//    Paderborn University
//    philipp.schubert@upb.de
//
//===----------------------------------------------------------------------===//

#include <chrono>
#include <iostream>

// TODO provide a recursive implementation
unsigned fibonacci_rec(unsigned n);

// TODO provide a non-recursive implementation
unsigned fibonacci_nonrec(unsigned n);

int main() {
  constexpr unsigned N = 50;
  // Test the recursive version
  std::cout << "Measuring the runtime for a call to fibonacci_rec(" << N
            << ")\n";
  auto start = std::chrono::steady_clock::now();
  std::cout << "F_" << N << " is: " << fibonacci_rec(N) << '\n';
  auto finish = std::chrono::steady_clock::now();
  auto elapsed_milliseconds =
      std::chrono::duration_cast<std::chrono::milliseconds>(finish - start)
          .count();
  std::cout << "Runtime: " << elapsed_milliseconds << "ms\n";

  // Test the non-recursive version
  std::cout << "Measuring the runtime for a call to fibonacci_nonrec(" << N
            << ")\n";
  start = std::chrono::steady_clock::now();
  std::cout << "F_" << N << " is: " << fibonacci_nonrec(N) << '\n';
  finish = std::chrono::steady_clock::now();
  elapsed_milliseconds =
      std::chrono::duration_cast<std::chrono::milliseconds>(finish - start)
          .count();
  std::cout << "Runtime: " << elapsed_milliseconds << "ms\n";
  return 0;
}
