//===----------------------------------------------------------------------===//
//
// Philipp Schubert
//
//    Copyright (c) 2017 - 2021
//    Secure Software Engineering Group
//    Heinz Nixdorf Institute
//    Paderborn University
//    philipp.schubert@upb.de
//
//===----------------------------------------------------------------------===//

#include <cmath>
#include <iostream>
#include <vector>

void print_dvector(const std::vector<double> &v) {
  for (const double &d : v) {
    std::cout << d << ' ';
  }
  std::cout << '\n';
}

// TODO provide an implementation.
double euclidean_length(const std::vector<double> &v);
// TODO provide an implementation.
double scalar_product(const std::vector<double> &v,
                      const std::vector<double> &w);
// TODO provide an implementation.
std::vector<double> normalize(std::vector<double> v);
// TODO provide an implementation.
double euclidean_distance(const std::vector<double> &v,
                          const std::vector<double> &w);

int main() {
  std::vector<double> a = {1, 2, 3};
  std::vector<double> b = {4, 5, 6};

  // You have to provide the implementations for the four function declarations
  // from above in order to make this code work.
  std::cout << "length of 'a': " << euclidean_length(a) << '\n';
  std::cout << "scalar product of 'a' and 'b': " << scalar_product(a, b)
            << '\n';
  print_dvector(normalize(a));
  std::cout << "distance between 'a' and 'b': " << euclidean_distance(a, b)
            << '\n';
  return 0;
}
